-- AddOn: PiggyBank
-- Version: 1.1.0
-- Developer: Jico

PiggyBank = {}

local PB = PiggyBank
local LAM = LibStub("LibAddonMenu-1.0")

local defaults =
{
	depositPercentage = 0.1,
	depositInterval = 5,
	lastDeposit = 0,
	maxDeposit = 0
}

local function Initialize( eventCode, addOnName )

	if (addOnName ~= "PiggyBank") then
		return
	end
	
	sv = ZO_SavedVars:NewAccountWide ( "PiggyBank_SavedVariables", 1, nil, defaults )
	CreateOptions()
	EVENT_MANAGER:RegisterForEvent( "PiggyBank", EVENT_OPEN_BANK, Deposit );
end

function CreateOptions()
	local optionsPanel = LAM:CreateControlPanel("PiggyBank_Options", "Piggy Bank Options")
	LAM:AddHeader(optionsPanel, "PiggyBank_Options_Use_Default", "Deposit Parameters")
	LAM:AddEditBox(optionsPanel, "ctl_Deposit_Precentage", "Percentage to Deposit:",
		"Enter as a number after the decimal (Example: 50% would be 0.5", false,
		function () return sv.depositPrecentage end,
		function(percent)sv.depositPercentage = tonumber(percent) end )
	LAM:AddEditBox(optionsPanel, "ctl_Deposit_Interval", "Min Deposit Interval:",
		"Enter in seconds", false,
		function () return sv.depositInterval end,
		function(interval) sv.depositInterval = tonumber(interval) end )
	LAM:AddEditBox(optionsPanel, "ctl_Max_Deposit", "Max amount to deposit::",
		"enter a number :)", false,
		function () return sv.maxDeposit end,
		function(max) sv.maxDeposit =tonumber(max) end )
end

local function GetDepositPercentage ()
	return sv.depositPrecentage
end

function SetDepositPercentage (percent)
	sv.depositPrecentage = percent / 100
end

function Deposit ()

	if (GetDiffBetweenTimeStamps(GetTimeStamp(), sv.lastDeposit) < sv.depositInterval ) then	
		return
	end
	
	local currentMoney = GetCurrentMoney()
	 
	if (currentMoney >= 10) then
		local depositAmount = GetCurrentMoney ( ) * sv.depositPercentage
		if (sv.maxDeposit == 0) then
			DepositMoneyIntoBank ( depositAmount )
			sv.lastDeposit = GetTimeStamp()
			d( string.format ( "PIGGYBANK: %d deposited", depositAmount ) )
		else
			if (depositAmount > sv.maxDeposit) then
				DepositMoneyIntoBank(sv.maxDeposit)
				sv.lastDeposit = GetTimeStamp()
				d( string.format ( "PIGGYBANK: %d deposited", depositAmount ) )
			else
				DepositMoneyIntoBank(depositAmount)
				sv.lastDeposit = GetTimeStamp()
				d( string.format ( "PIGGYBANK: %d deposited", depositAmount ) )
			end
		end
	end
end

EVENT_MANAGER:RegisterForEvent ( "PiggyBank", EVENT_ADD_ON_LOADED, Initialize )	